/**

2002 ZORAN Corporation, All Rights Reserved THIS IS PROPRIETARY SOURCE CODE OF
ZORAN CORPORATION

%file

  AvfApi.c

%desc

%author

  Pavel Piarvou

%created

  April 16, 2008

*/

#include <assert.h>

#include "Types.h"
#include "AvCodec.h"
#include "Avformat.h"
#include "..\Include\AvApi.h"

/*
    %Func:
        AvApi_register_avcodec
    %Desc:

*/
void AvApi_register_avcodec(AVCodec *format)
{
    register_avcodec(format);
}

/*
    %Func:
        AvApi_avcodec_alloc_context
    %Desc:
        allocates a AVCodecContext and set it to defaults.
        this can be deallocated by simply calling free()
*/
AVCodecContext *AvApi_avcodec_alloc_context(void)
{
    AVCodecContext* retVal = NULL;

    retVal = avcodec_alloc_context();

    return retVal;
}

/*
    %Func:
        AvApi_avcodec_alloc_frame
    %Desc:
     allocates a AVPFrame and set it to defaults.
     this can be deallocated by simply calling free()

*/
AVFrame *AvApi_avcodec_alloc_frame(void)
{
    AVFrame* retVal = NULL;

    retVal = avcodec_alloc_frame();

    return retVal;
}

/*
    %Func:
        AvApi_avcodec_open
    %Desc:

*/
int AvApi_avcodec_open(AVCodecContext *avctx, AVCodec *codec)
{
    int retVal = 0;

    retVal = avcodec_open(avctx, codec);

    return retVal;
}


/*
    %Func:
        AvApi_avcodec_encode_audio
    %Desc:

*/
int AvApi_avcodec_encode_audio( AVCodecContext *avctx,
                                uint8_t *buf,
                                int buf_size,
                                const short *samples)
{
    int retVal = 0;

    retVal = avcodec_encode_audio(avctx, buf, buf_size, samples);

    return retVal;
}

/*
    %Func:
        AvApi_avcodec_encode_video
    %Desc:

*/
int AvApi_avcodec_encode_video( AVCodecContext *avctx,
                                uint8_t *buf,
                                int buf_size,
                                const AVFrame *pict)
{
    int retVal = 0;

    retVal = avcodec_encode_video(avctx, buf, buf_size, pict);

    return retVal;
}


/*
    %Func:
        AvApi_avcodec_decode_video
    %Desc:
        decode a frame.
    %Param:
        param buf   -   bitstream buffer, must be FF_INPUT_BUFFER_PADDING_SIZE
                        larger then the actual read bytes because some
                        optimized bitstream readers read 32 or 64 bit at once
                        and could read over the end

        param buf_size  -   the size of the buffer in bytes
        got_picture_ptr -   zero if no frame could be decompressed, otherwise,
                            it is non zero
    %Return
    -1 if error, otherwise return the number of bytes used.

*/
int AvApi_avcodec_decode_video( AVCodecContext *avctx,
                                AVFrame *picture,
                                int *got_picture_ptr,
                                uint8_t *buf,
                                int buf_size)
{
    int retVal = 0;

    retVal = avcodec_decode_video(  avctx,
                                        picture,
                                        got_picture_ptr,
                                        buf,
                                        buf_size);

    return retVal;

}


/*
    %Func:
        AvApi_avcodec_decode_audio
    %Desc:

*/
int AvApi_avcodec_decode_audio( AVCodecContext *avctx,
                                int16_t *samples,
                                int *frame_size_ptr,
                                uint8_t *buf,
                                int buf_size)
{
    int retVal = 0;

    retVal = avcodec_decode_audio(  avctx,
                                        samples,
                                        frame_size_ptr,
                                        buf,
                                        buf_size);

    return retVal;

}

/*
    %Func:
        AvApi_avcodec_close
    %Desc:

*/
int AvApi_avcodec_close(AVCodecContext *avctx)
{
    int retVal = 0;

    retVal = avcodec_close(avctx);

    return retVal;
}

/*
    %Func:
        AvApi_avcodec_find_encoder
    %Desc:

*/
AVCodec *AvApi_avcodec_find_encoder(enum CodecID id)
{
    AVCodec* retVal = NULL;

    retVal = avcodec_find_encoder(id);

    return retVal;
}

/*
    %Func:
        AvApi_avcodec_find_encoder_by_name

    %Desc:

*/
AVCodec *AvApi_avcodec_find_encoder_by_name(const char *name)
{
    AVCodec* retVal = NULL;

    retVal = avcodec_find_encoder_by_name(name);

    return retVal;

}

/*
    %Func:
        AvApi_avcodec_find_decoder

    %Desc:

*/
AVCodec *AvApi_avcodec_find_decoder(enum CodecID id)
{
    AVCodec* retVal = NULL;

    retVal = avcodec_find_decoder(id);

    return retVal;
}

/*
    %Func:
        AvApi_avcodec_find_decoder_by_name

    %Desc:

*/
AVCodec *AvApi_avcodec_find_decoder_by_name(const char *name)
{
    AVCodec* retVal = NULL;

    retVal = avcodec_find_decoder_by_name(name);

    return retVal;

}




/*
    %Func:
        AvApi_avcodec_get_context_defaults

    %Desc:

    %Return:
        None.
*/
VOID
AvApi_avcodec_get_context_defaults(AVCodecContext *s)
{
    avcodec_get_context_defaults(s);
}

/*
    %Func:
        AvApi_rescale

    %Desc:

    %Return:
        None.
*/
int64_t
AvApi_rescale(int64_t a, int b, int c)
{
    int64_t retVal = 0;

    retVal = av_rescale(a, b, c);

    return retVal;
}


/*
	%Func:
		AvApi_avcodec_set_thread_priorities

	%Desc:

	%Return:
		None.
*/
void 
AvApi_avcodec_set_thread_priorities(int priority)
{
    CodecSetPriorities(priority);
}

/*
    %Func:
        AvApi_avcodec_set_operation_mode

    %Desc:

    %Return:
        None.
*/

void 
AvApi_avcodec_set_operation_mode( ECodecOperationMode mode )
{
#if (FW_VERSION == FW_VERSION_C13)
    // This code is removed due to dynamic linkage error with undefined CodecSetOperationMode
    assert(0);
#else
    CodecSetOperationMode(mode);
#endif
}


/*
    %Func:
        AvApi_avpicture_fill    

    Picture field are filled with 'ptr' addresses. Also return size 
*/
int AvApi_avpicture_fill( AVPicture *picture, 
                          uint8_t *ptr,
                          int pix_fmt, 
                          int width, 
                          int height)
{
    int retVal = 0;
    
    retVal = Av_avpicture_fill(picture, ptr, pix_fmt, width, height);

    return retVal;
}
