/**

%file AvModule.h

%desc Main header file of Av module

*/

////////////////////////////////////////////////////////////////////////////////
// DLL switches. Must be defined before including "ModHeader.h"
////////////////////////////////////////////////////////////////////////////////

#define MOD_NAME Av // Module name

#define MOD_DEBUG    // Use this if you want that check
                     // whether module is loaded is done
                     // before each DLL function call

////////////////////////////////////////////////////////////////////////////////
// AvModule declarations
////////////////////////////////////////////////////////////////////////////////
#ifndef __AV_MODULE_H__
#define __AV_MODULE_H__

#endif//__AV_MODULE_H__

////////////////////////////////////////////////////////////////////////////////
// Including "ModHeader.h"
////////////////////////////////////////////////////////////////////////////////

#include "ModHeader.h"

////////////////////////////////////////////////////////////////////////////////
// Export table definition
////////////////////////////////////////////////////////////////////////////////

MOD_DECLARE_MODULE(MOD_ARG_TO_STR_DER(MOD_NAME))

MOD_EXPORT_BEGIN
//functions
// Av Api
    MOD_EXPORT_FUNC(AvGetCodecAllocContextFn)
    MOD_EXPORT_FUNC(AvGetCodecAllocFrameFn)
    MOD_EXPORT_FUNC(AvGetCodecCloseFn)
    MOD_EXPORT_FUNC(AvGetCodecDecodeAudioFn)
    MOD_EXPORT_FUNC(AvGetCodecDecodeVideoFn)
    MOD_EXPORT_FUNC(AvGetCodecEncodeAudioFn)
    MOD_EXPORT_FUNC(AvGetCodecEncodeVideoFn)
    MOD_EXPORT_FUNC(AvGetCodecFindDecoderByNameFn)
    MOD_EXPORT_FUNC(AvGetCodecFindDecoderFn)
    MOD_EXPORT_FUNC(AvGetCodecFindEcoderByNameFn)
    MOD_EXPORT_FUNC(AvGetCodecFindEncoderFn)
    MOD_EXPORT_FUNC(AvGetCodecGetContextDefaultsFn)
    MOD_EXPORT_FUNC(AvGetCodecInitFn)
    MOD_EXPORT_FUNC(AvGetCodecOpenFn)
    MOD_EXPORT_FUNC(AvGetCodecRegisterFn)
    MOD_EXPORT_FUNC(AvGetMepSetCodeBufFn)
    MOD_EXPORT_FUNC(AvGetPictureFillFn)
    MOD_EXPORT_FUNC(GetAvGetAaczDecoderFn)
    MOD_EXPORT_FUNC(GetAvGetAaczEncoderFn)
    MOD_EXPORT_FUNC(GetAvGetAdpcm4xmDecoderFn)
    MOD_EXPORT_FUNC(GetAvGetAdpcm4xmEncoderFn)
    MOD_EXPORT_FUNC(GetAvGetAdpcmAdxDecoderFn)
    MOD_EXPORT_FUNC(GetAvGetAdpcmAdxEncoderFn)
    MOD_EXPORT_FUNC(GetAvGetAdpcmEaDecoderFn)
    MOD_EXPORT_FUNC(GetAvGetAdpcmEaEncoderFn)
    MOD_EXPORT_FUNC(GetAvGetAdpcmImaDk3DecoderFn)
    MOD_EXPORT_FUNC(GetAvGetAdpcmImaDk3EncoderFn)
    MOD_EXPORT_FUNC(GetAvGetAdpcmImaDk4DecoderFn)
    MOD_EXPORT_FUNC(GetAvGetAdpcmImaDk4EncoderFn)
    MOD_EXPORT_FUNC(GetAvGetAdpcmImaQtDecoderFn)
    MOD_EXPORT_FUNC(GetAvGetAdpcmImaQtEncoderFn)
    MOD_EXPORT_FUNC(GetAvGetAdpcmImaSmjpegDecoderFn)
    MOD_EXPORT_FUNC(GetAvGetAdpcmImaSmjpegEncoderFn)
    MOD_EXPORT_FUNC(GetAvGetAdpcmImaWavDecoderFn)
    MOD_EXPORT_FUNC(GetAvGetAdpcmImaWavEncoderFn)
    MOD_EXPORT_FUNC(GetAvGetAdpcmImaWsDecoderFn)
    MOD_EXPORT_FUNC(GetAvGetAdpcmImaWsEncoderFn)
    MOD_EXPORT_FUNC(GetAvGetAdpcmMsDecoderFn)
    MOD_EXPORT_FUNC(GetAvGetAdpcmMsEncoderFn)
    MOD_EXPORT_FUNC(GetAvGetAdpcmXaDecoderFn)
    MOD_EXPORT_FUNC(GetAvGetAdpcmXaEncoderFn)
    MOD_EXPORT_FUNC(GetAvGetH264zDecoderFn)
    MOD_EXPORT_FUNC(GetAvGetJpegzDecoderFn)
    MOD_EXPORT_FUNC(GetAvGetMjpegDecoderFn)
    MOD_EXPORT_FUNC(GetAvGetMjpegEncoderFn)
    MOD_EXPORT_FUNC(GetAvGetMp2DecoderFn)
    MOD_EXPORT_FUNC(GetAvGetMp2EncoderFn)
    MOD_EXPORT_FUNC(GetAvGetMpeg1zDecoderFn)
    MOD_EXPORT_FUNC(GetAvGetMpeg1zEncoderFn)
    MOD_EXPORT_FUNC(GetAvGetMpeg2zEncoderFn)
    MOD_EXPORT_FUNC(GetAvGetMpeg4zDecoderFn)
    MOD_EXPORT_FUNC(GetAvGetMpeg4zEncoderFn)
    MOD_EXPORT_FUNC(GetAvGetPcmAlawDecoderFn)
    MOD_EXPORT_FUNC(GetAvGetPcmAlawEncoderFn)
    MOD_EXPORT_FUNC(GetAvGetPcmH264zEncoderFn)
    MOD_EXPORT_FUNC(GetAvGetPcmMulawDecoderFn)
    MOD_EXPORT_FUNC(GetAvGetPcmMulawEncoderFn)
    MOD_EXPORT_FUNC(GetAvGetPcmS16beDecoderFn)
    MOD_EXPORT_FUNC(GetAvGetPcmS16beEncoderFn)
    MOD_EXPORT_FUNC(GetAvGetPcmS16leDecoderFn)
    MOD_EXPORT_FUNC(GetAvGetPcmS16leEncoderFn)
    MOD_EXPORT_FUNC(GetAvGetPcmS8DecoderFn)
    MOD_EXPORT_FUNC(GetAvGetPcmS8EncoderFn)
    MOD_EXPORT_FUNC(GetAvGetPcmU16beDecoderFn)
    MOD_EXPORT_FUNC(GetAvGetPcmU16beEncoderFn)
    MOD_EXPORT_FUNC(GetAvGetPcmU16leDecoderFn)
    MOD_EXPORT_FUNC(GetAvGetPcmU16leEncoderFn)
    MOD_EXPORT_FUNC(GetAvGetPcmU8DecoderFn)
    MOD_EXPORT_FUNC(GetAvGetPcmU8EncoderFn)
    MOD_EXPORT_FUNC(GetAvGetRawzDecoderFn)
    MOD_EXPORT_FUNC(GetAvGetRawzEncoderFn)
// Other functions
    MOD_EXPORT_FUNC(AvApi_avcodec_find_decoder)
    MOD_EXPORT_FUNC(AvApi_avcodec_find_encoder)
    MOD_EXPORT_FUNC(AvApi_avcodec_get_context_defaults)
    MOD_EXPORT_FUNC(AvApi_avcodec_init)
    MOD_EXPORT_FUNC(AvApi_rescale)
    MOD_EXPORT_FUNC(AvLibRegister)
    MOD_EXPORT_FUNC(AvSetOperationMode)
    MOD_EXPORT_FUNC(AvSetThreadPriorities)
    MOD_EXPORT_FUNC(Av_avpicture_fill)
    MOD_EXPORT_FUNC(AvzLibRegister)
    MOD_EXPORT_FUNC(AvzSetReadResourceCallback)
    MOD_EXPORT_FUNC(av_free_ex)
    MOD_EXPORT_FUNC(av_malloc_ex)
    MOD_EXPORT_FUNC(av_mallocz_ex)
    MOD_EXPORT_FUNC(av_mem_lock)
    MOD_EXPORT_FUNC(av_realloc_ex)
    MOD_EXPORT_FUNC(av_reduce)
    MOD_EXPORT_FUNC(avcodec_close)
    MOD_EXPORT_FUNC(avcodec_decode_audio)
    MOD_EXPORT_FUNC(avcodec_decode_video)
    MOD_EXPORT_FUNC(avcodec_find_decoder)
    MOD_EXPORT_FUNC(avcodec_open)
    MOD_EXPORT_FUNC(avpicture_get_size)
    MOD_EXPORT_FUNC(flush_put_bits)
#if (FW_VERSION != FW_VERSION_C13)
    MOD_EXPORT_FUNC(h264_encode_skip_frame)
    MOD_EXPORT_FUNC(h264_write_sei_messages)
    MOD_EXPORT_FUNC(h264z_add_stuffing_bits)
    MOD_EXPORT_FUNC(h264z_encode_custom_nals)
    MOD_EXPORT_FUNC(h264z_encode_preconfig)
    MOD_EXPORT_FUNC(h264z_encode_slice_header_2vc)
    MOD_EXPORT_FUNC(h264z_get_slice_type)
#endif
    MOD_EXPORT_FUNC(init_get_bits)
    MOD_EXPORT_FUNC(init_put_bits)
//uninitialized data
    MOD_EXPORT(gsChannelStatus)
    MOD_EXPORT(guwPlaybackHeaderCount)
//initialized data
    MOD_EXPORT(mp3_decoder)
    MOD_EXPORT(sIMAAdpcmProc)
    MOD_EXPORT(sMsAdpcmProc)
//read only data
    MOD_EXPORT(ff_golomb_vlc_len)
    MOD_EXPORT(ff_interleaved_golomb_vlc_len)
    MOD_EXPORT(ff_interleaved_se_golomb_vlc_code)
    MOD_EXPORT(ff_interleaved_ue_golomb_vlc_code)
    MOD_EXPORT(ff_log2_tab)
    MOD_EXPORT(ff_se_golomb_vlc_code)
    MOD_EXPORT(ff_ue_golomb_len)
    MOD_EXPORT(ff_ue_golomb_vlc_code)

MOD_EXPORT_END

MOD_IMPORT_TABLE_BEGIN

    MOD_IMPORT_BEGIN("DMC")
        MOD_IMPORT_ANY
    MOD_IMPORT_END

    MOD_IMPORT_BEGIN("sys")
        MOD_IMPORT_ANY
    MOD_IMPORT_END

MOD_IMPORT_TABLE_END
