/**
 * @file mpegaudio.h
 * mpeg audio declarations for both encoder and decoder.
 */

/* max frame size, in samples */
#define MPA_FRAME_SIZE 1152 

/* max compressed frame size */
#define MPA_MAX_CODED_FRAME_SIZE 1792

#define MPA_MAX_CHANNELS 2

#define SBLIMIT 32 /* number of subbands */

#define MPA_STEREO  0
#define MPA_JSTEREO 1
#define MPA_DUAL    2
#define MPA_MONO    3

#define SAMPLES_BUF_ADDR 0
#define FILTER_BANK_ADDR 0
#define COSTAB32_ADDR    costab32
#define BITINV32_ADDR    bitinv32
#define TMP_ADDR         0
#define TMP1_ADDR        0

void idct32_part1( int *tab );
void idct32_part2( int* tab, const int* xp );
void idct32_part3( int *tab, int *out );


int l2_select_table(int bitrate, int nb_channels, int freq, int lsf);

extern const uint16_t mpa_bitrate_tab[2][3][15];
extern const uint16_t mpa_freq_tab[3];
extern const unsigned char *alloc_tables[5];
extern const double enwindow[512];
extern const int sblimit_table[5];
extern const int quant_steps[17];
extern const int quant_bits[17];
extern const int32_t mpa_enwindow[257];
