/**

2002 ZORAN Corporation, All Rights Reserved THIS IS PROPRIETARY SOURCE CODE OF
ZORAN CORPORATION

%file

  AvCodec.c

%desc

%author

  Pavel Piarvou

%created

  March 7, 2008

*/

#include <assert.h>

#include "av.h"
#include "AvCodec.h"

#ifndef BUILD_VERILOG
AVCodec*
AvGetCodecMp2Encoder(void)
{
	return &mp2_encoder;
}
#endif


AVCodec*
AvGetCodecPcmH264zEncoder(void)
{
#if (FW_VERSION == FW_VERSION_C13)
    // This code is removed due to dynamic linkage error with undefined h264z_encoder
    assert(0);
    return NULL;
#else 
    return &h264z_encoder;
#endif   
}

#ifndef BUILD_VERILOG
AVCodec*
AvGetCodecMp2Decoder(void)
{
	return &mp2_decoder;
}
#endif


AVCodec*
AvGetCodecJpegzDecoder(void)
{
#if (FW_VERSION == FW_VERSION_C13)
    // This code is removed due to dynamic linkage error with undefined jpegz_decoder
    assert(0);
    return NULL;
#else 
    return &jpegz_decoder;
#endif   
}

AVCodec*
AvGetCodecRawzEncoder(void)
{
	return &rawz_encoder;
}

AVCodec*
AvGetCodecRawzDecoder(void)
{
	return &rawz_decoder;
}

AVCodec*
AvGetCodecH264zDecoder(void)
{
#if (FW_VERSION == FW_VERSION_C13)
    // This code is removed due to dynamic linkage error with undefined h264z_decoder
    assert(0);
    return NULL;
#else 
    return &h264z_decoder;
#endif   
}


#ifdef AACZ_DECODER
AVCodec*
AvGetCodecAaczDecoder(void)
{
	return &aacz_decoder;
}
#endif

#ifdef AACZ_ENCODER
AVCodec*
AvGetCodecAaczEncoder(void)
{
	return &aacz_encoder;
}
#endif


