/**

%file AvfModule.h

%desc Main header file of Av module

*/

////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// DLL switches. Must be defined before including "ModHeader.h"
////////////////////////////////////////////////////////////////////////////////

#define MOD_NAME Avf // Module name

#define MOD_DEBUG    // Use this if you want that check
                     // whether module is loaded is done
                     // before each DLL function call

////////////////////////////////////////////////////////////////////////////////
// Including "ModHeader.h"
////////////////////////////////////////////////////////////////////////////////

#include "ModHeader.h"

////////////////////////////////////////////////////////////////////////////////
// AvfModule declarations
////////////////////////////////////////////////////////////////////////////////
#ifndef __AVF_MODULE_H__
#define __AVF_MODULE_H__

//#define AVF_JPEG

#endif//__AVF_MODULE_H__

////////////////////////////////////////////////////////////////////////////////
// Export table definition
////////////////////////////////////////////////////////////////////////////////

MOD_DECLARE_MODULE(MOD_ARG_TO_STR_DER(MOD_NAME))

MOD_EXPORT_BEGIN
//functions
// Avf Api
    MOD_EXPORT_FUNC(AvGetAddStreamFn)
    MOD_EXPORT_FUNC(AvGetAsfInitFn)
    MOD_EXPORT_FUNC(AvGetAuInitFn)
    MOD_EXPORT_FUNC(AvGetAviDecInitFn)
    MOD_EXPORT_FUNC(AvGetAviEncInitFn)
    MOD_EXPORT_FUNC(AvGetCloseInputFileFn)
    MOD_EXPORT_FUNC(AvGetCodecAvFindStreamInfoFn)
    MOD_EXPORT_FUNC(AvGetCodecAvNewStreamFn)
    MOD_EXPORT_FUNC(AvGetDeletePacketFn)
    MOD_EXPORT_FUNC(AvGetDirectGetDataFn)
    MOD_EXPORT_FUNC(AvGetDirectPutDataFn)
    MOD_EXPORT_FUNC(AvGetDirectQueueProtocolFn)
    MOD_EXPORT_FUNC(AvGetDumpFormatFn)
    MOD_EXPORT_FUNC(AvGetEstimateTrailerSizeFn)
    MOD_EXPORT_FUNC(AvGetExifInitFn)
    MOD_EXPORT_FUNC(AvGetFileEntryGetFn)
    MOD_EXPORT_FUNC(AvGetFileEntrySetFn)
    MOD_EXPORT_FUNC(AvGetFileProtocolFn)
    MOD_EXPORT_FUNC(AvGetFindInputFormatFn)
    MOD_EXPORT_FUNC(AvGetFreePacketFn)
    MOD_EXPORT_FUNC(AvGetGetCustomTagInfoFn)
    MOD_EXPORT_FUNC(AvGetGetParametersFn)
    MOD_EXPORT_FUNC(AvGetGetStreamFramesNumberFn)
    MOD_EXPORT_FUNC(AvGetGetTotalPresentVideoFramesNumberFn)
    MOD_EXPORT_FUNC(AvGetGetTotalWrittenVideoFramesNumberFn)
    MOD_EXPORT_FUNC(AvGetGuessFormatFn)
    MOD_EXPORT_FUNC(AvGetImgInitFn)
    MOD_EXPORT_FUNC(AvGetJpegInitFn)
    MOD_EXPORT_FUNC(AvGetMediaGetFn)
    MOD_EXPORT_FUNC(AvGetMediaSetFn)
    MOD_EXPORT_FUNC(AvGetMovDecInitFn)
    MOD_EXPORT_FUNC(AvGetMovEncInitFn)
    MOD_EXPORT_FUNC(AvGetMpegPsInitFn)
    MOD_EXPORT_FUNC(AvGetMpegTInitFn)
    MOD_EXPORT_FUNC(AvGetOpenInputFileFn)
    MOD_EXPORT_FUNC(AvGetParseTrailerInfoFn)
    MOD_EXPORT_FUNC(AvGetRawInitFn)
    MOD_EXPORT_FUNC(AvGetReadIsKeyframeFn)
    MOD_EXPORT_FUNC(AvGetReadPacketFn)
    MOD_EXPORT_FUNC(AvGetReadSeekFn)
    MOD_EXPORT_FUNC(AvGetReadSeekIdxFn)
    MOD_EXPORT_FUNC(AvGetReadTextStreamFn)
    MOD_EXPORT_FUNC(AvGetRegisterImageFormatFn)
    MOD_EXPORT_FUNC(AvGetRegisterInputFormatCustomProbeCallbackFn)
    MOD_EXPORT_FUNC(AvGetRegisterInputFormatErrorCallbackFn)
    MOD_EXPORT_FUNC(AvGetRegisterOutputFormatCallbackFn)
    MOD_EXPORT_FUNC(AvGetRegisterProtocolFn)
    MOD_EXPORT_FUNC(AvGetRmInitFn)
    MOD_EXPORT_FUNC(AvGetSeekLastChunkEndPosFn)
    MOD_EXPORT_FUNC(AvGetSetCustomTagInfoFn)
    MOD_EXPORT_FUNC(AvGetSetParametersFn)
    MOD_EXPORT_FUNC(AvGetSetStreamContentInfoFn)
    MOD_EXPORT_FUNC(AvGetUrlFCloseFn)
    MOD_EXPORT_FUNC(AvGetUrlFOpenFn)
    MOD_EXPORT_FUNC(AvGetUrlFSeekEndFn)
    MOD_EXPORT_FUNC(AvGetUrlFSeekFn)
    MOD_EXPORT_FUNC(AvGetVideoToTextFn)
    MOD_EXPORT_FUNC(AvGetWavInitFn)
    MOD_EXPORT_FUNC(AvGetWriteFrameFn)
    MOD_EXPORT_FUNC(AvGetWriteHeaderFn)
    MOD_EXPORT_FUNC(AvGetWriteTrailerFn)
    MOD_EXPORT_FUNC(AvGetYuvImageFormatFn)
// Other functions
    MOD_EXPORT_FUNC(AvfApi_avcodec_init)
    MOD_EXPORT_FUNC(AvfAvioGetLastError)
    MOD_EXPORT_FUNC(AvfLibRegister)
    MOD_EXPORT_FUNC(Avf_ModifyDefaultTag)
    MOD_EXPORT_FUNC(mov_set_globalTimescale)
    MOD_EXPORT_FUNC(avf_free_ex)
    MOD_EXPORT_FUNC(avf_malloc_ex)
    MOD_EXPORT_FUNC(avf_mallocz_ex)
    MOD_EXPORT_FUNC(avf_realloc_ex)

MOD_EXPORT_END

MOD_IMPORT_TABLE_BEGIN

    MOD_IMPORT_BEGIN("Av")
        MOD_IMPORT_ANY
    MOD_IMPORT_END

    MOD_IMPORT_BEGIN("DMC")
        MOD_IMPORT_ANY
    MOD_IMPORT_END

    MOD_IMPORT_BEGIN("sys")
        MOD_IMPORT_ANY
    MOD_IMPORT_END

MOD_IMPORT_TABLE_END
